@echo off
goto :start

rem Validate all the digital signatures found in a UBL document
rem
rem Use only a single argument: 
rem     inputDoc
rem 
rem $Id: verifyUBL.bat,v 1.2 2010/11/27 21:40:08 admin Exp $
rem
rem Copyright (C) - Crane Softwrights Ltd.
rem               - http://www.CraneSoftwrights.com/links/res-dev.htm
rem 
rem Redistribution and use of components created by Crane Softwrights Ltd. in 
rem source and binary forms, with or without modification, are permitted 
rem provided that the following conditions are met:
rem 
rem - Redistributions of source code must retain the above copyright notice,
rem   this list of conditions and the following disclaimer.
rem - Redistributions in binary form must reproduce the above copyright notice,
rem   this list of conditions and the following disclaimer in the documentation
rem   and/or other materials provided with the distribution.
rem - The name of the author may not be used to endorse or promote products
rem   derived from this software without specific prior written permission.
rem 
rem THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
rem IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
rem OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
rem NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
rem SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
rem TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
rem PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
rem LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
rem NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE
rem EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
rem 
rem Note:for your reference, the above is the "Modified BSD license", this text
rem   was obtained 2003-07-26 at http://www.xfree86.org/3.3.6/COPYRIGHT2.html#5
rem 
rem THE AUTHOR MAKES NO REPRESENTATION ABOUT THE SUITABILITY OF THIS CODE FOR 
rem ANY PURPOSE. PLEASE CONSULT THE RESPECTIVE RESPONSIBLE PARTIES REGARDING 
rem COPYRIGHT AND LEGAL OBLIGATIONS FOR COMPONENTS NOT WRITTEN BY CRANE 
rem SOFTWRIGHTS LTD.

:start
if not "a%~2" == "a" goto :help
if not exist "%~1" goto :notfound
if not exist "%~dp0saxon.jar" goto :nosaxon

set signIDAttrs=--id-attr:Id "http://www.w3.org/2000/09/xmldsig#:Signature" --id-attr:Id "http://www.w3.org/2000/09/xmldsig#:SignatureValue"

echo Preparing verification of the document...
java -jar "%~dp0saxon.jar" -o "%~1.bat" "%~1" "%~dp0Crane-VerifyUBL.xsl" "isDOS=yes" "infile=%~1"
if %errorlevel% neq 0 goto :badverify
echo Verifying the document...
call "%~1.bat"
set verifyUBL=%errorlevel%
del "%~1.bat"
exit /b %verifyUBL%
rem It shouldn't get here because of the above is not called, but jump anyway
goto :done

:notfound
echo Input file "%~1" not found
goto :error
:nosaxon
echo The Saxon XSLT processor JAR file not found.  
echo Please review the documentation.
goto :error
:badverify
echo Stylesheet verifying signature information failed
if exist "%~2" del "%~2"
goto :error
:error
echo Execution terminated.
:help
echo Use only a single argument: 
echo     inputDoc
exit /b 1
:done
exit /b 0
